	include		tios.h
	include		filelib.h
	xdef		_ti89
	xdef		_main
	xdef		_comment
	xdef		_exit

	include		"presets.h"
	include		"macros.asm"
	include		"levels.asm"
	include		"refrlevl.asm"
	include		"lib.asm"
	include		"objects.asm"
	include		"initobj.asm"
	include		"initdead.asm"


_main:
	bclr.b		#2,$600001		;disable int1, change int5
	move.l		($74).w,oldint_addr+4
	move.l		#FlagCall,($74).w
	move.w		#$00D4,$600016		;change # of fps
	move.w		#$400,d0
	trap		#1

	move.l		sp,orig_sp		;save orig sp
	bsr		AllocateSpace		;initialize jdata\jdata1: 30kb
	cmp.l		#-1,d0
	beq		_exit_noheap

	
MakeScreen:

	move.l		file_loc,d0	;set up screens
	add.l		#16000,d0
	move.l		d0,Screen
	add.l		#4096,d0
	move.l		d0,Screen+4
	add.l		#4096,d0
	move.l		d0,Screen+8

	move.l		file_loc,d0	;set up stack
	add.l		#15000,d0
	move.l		d0,Stack

	
ClearFile:
	move.l		file_loc,a0
	adda.l		#2,a0
	move.l		#3998,d1
ClearFile_loop:	
	move.l		#0,(a0)+
	dbra.w		d1,ClearFile_loop

	move.l		#$10000,LevelNum
LevelLoop:
	add.l		#1,LevelNum
	move.l		LevelNum,d0
	cmp.l		#5,d0
	bne		NotLevel5
	move.l		#1,LevelNum
NotLevel5:
	move.l		#0,CurrScreenNum
	move.l		#0,rotate
	move.l		#0,rotate+4
	move.l		#0,d0
	move.w		LevelNum+2,d0
	mulu		#4,d0
	move.l		Levels,a0  
	add.l		d0,a0
	move.l		(a0),a0

	jsr		(a0)		;run level 1

;Loop for level
RedispLevel:

	move.w		#(ScreenBottom-ScreenTop)*30/4-1,d1	;SwapCls Macro
	move.l		Screen,a0
	move.l		#$4c00,a1
	move.l		Screen+4,a2
	move.l		Screen+8,a3
	adda.l		#30*(ScreenTop),a0
	adda.l		#30*(ScreenTop),a1
	adda.l		#30*(ScreenTop),a2
	adda.l		#30*(ScreenTop),a3
Swap1_Loop:
	move.l		(a0),(a1)+
	move.l		#$0,(a0)+
	move.l		#$0,(a2)+
	move.l		#$0,(a3)+
	dbra.w		d1,Swap1_Loop

;	jsr		ClearScreenTop


	add.l		#1,rotate
	cmp.l		#4,rotate
	bne		dontrotate1yet
	move.l		#0,rotate
	add.l		#1,rotate+4
	cmp.l		#32,rotate+4
	bne		dontrotate1yet
	move.l		#0,rotate+4
dontrotate1yet:

	move.l		a6,a5			;set up object window
objloop:
	move.l		(a5),a0			;begin object loop
	jsr		(a0)
	add.l		#44,a5
	cmp.l		HarrLoc,a5
	ble		objloop

	move.l		a6,a5			;set up crash loop
crashloop:
	clr.l		d5			;begin crash loop
	bsr		CrashTest
	cmp.l		#0,d5
	beq		NoCrash 
	sub.b		#1,38(a5)
	cmp.b		#0,38(a5)
	bgt		NoCrash
	move.l		4(a5),a0
	jsr		(a0)
NoCrash:
	add.l		#44,a5
	cmp.l		HarrLoc,a5
	ble		crashloop



;	tst.b		None			;lines are to ensure that cycle
;	beq		WaitForInterval		;is completed within the amount
;	move.l		#$00000001,d0		;of time specified by adding 1
;	jsr		AddScore		;point for each frame that is late


WaitForInterval:				;wait for int5
	tst.b		None
	beq		WaitForInterval
	sf		None
	move.l		ObjectiveLoc,a0
	move.l		40(a0),d0
	cmp.l		#1,d0
	beq		LevelLoop
	btst		#0,(KeyData+6)		;esc key pressed?
	beq		_exit
	bra		RedispLevel

_exit:
;	jsr		ClearAlloc

_exit_noheap:
	move.l		orig_sp,sp
	move.l		oldint_addr+4,($74).w   ;restate int5
	move.w		#$00B2,$600016		;reset rate of int5
	bset.b		#2,$600001		;disable low memory access
	move.w		#$0,d0			;reenable int1
	trap		#1
	rts

FlagCall:
	st		None
	move.l		d0,-(a7)
	move.l		CurrScreenNum,d0	;choose which screen
	add.l		#1,d0
	move.l		d0,CurrScreenNum
	cmp.l		#2,d0
	ble		Not3
	move.l		#0,CurrScreenNum
Not3:
	move.l		(a7)+,d0
	rte

	include		"extraram.asm"
	include		"sprites.asm"
	include		"explode.asm"
	include		"data.asm"
	end